#include <stdio.h>
#include <io.h>
#include <assert.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <dos.h>
#include <dir.h>

class WriteBMPFile {
  int modwidth,pos,maxpos;
  unsigned char *zeile;
  FILE *stream;
public:
  WriteBMPFile(const char* name,long int width, long int height,long int colors,unsigned char *palette);
  ~WriteBMPFile();
  void Pixel(unsigned char col);
  void WriteLine();
  void NewLine();
  void ZeileAuffuellen();
};

WriteBMPFile::WriteBMPFile(const char* name,long int width, long int height,long int colors,unsigned char *palette) {
  printf("writing %s ",name);
  stream=fopen(name,"wb");
  long int filesize,datasize;
  long int dataoffset,infoheaderlen,longbuffer;
  short int nullint=0;

  modwidth = ( 4 - width % 4 )%4;
  datasize=(width+modwidth)*height;
  dataoffset=14+40+colors*4;
  filesize=datasize+dataoffset;
  fprintf(stream,"BM");
  fwrite(&filesize,sizeof(long int),1, stream);
  fwrite(&nullint,sizeof(short int),1, stream);
  fwrite(&nullint,sizeof(short int),1, stream);
  fwrite(&dataoffset,sizeof(long int),1, stream);
  infoheaderlen=40;
  fwrite(&infoheaderlen,sizeof(long int),1, stream);
  fwrite(&width,sizeof(long int),1, stream);
  fwrite(&height,sizeof(long int),1, stream);
  nullint=1;
  fwrite(&nullint,sizeof(short int),1, stream);
  nullint=8;
  fwrite(&nullint,sizeof(short int),1, stream);
  nullint=0;
  longbuffer=0;
  fwrite(&longbuffer,sizeof(long int),1, stream);
  fwrite(&datasize,sizeof(long int),1, stream);
  longbuffer=0;
  fwrite(&longbuffer,sizeof(long int),1, stream);
  fwrite(&longbuffer,sizeof(long int),1, stream);
  fwrite(&colors,sizeof(long int),1, stream);
  fwrite(&colors,sizeof(long int),1, stream);
  fwrite(palette,1,4*colors,stream);
  zeile=(unsigned char *)malloc(width);
  pos=0;
  maxpos=width;
}

WriteBMPFile::~WriteBMPFile() {
  fclose(stream);
}

void WriteBMPFile::Pixel(unsigned char col) {
  if (pos<maxpos) {
	 zeile[pos]=col;
	 pos++;
  }
}

void WriteBMPFile::WriteLine() {
  fwrite(zeile,1,maxpos,stream);
  ZeileAuffuellen();
}

void WriteBMPFile::NewLine() {
  pos=0;
}

void WriteBMPFile::ZeileAuffuellen() {
  unsigned char nullbyte=0;
  int x;
  for (x=0;x<modwidth;x++)  fwrite(&nullbyte,sizeof(char),1,stream);
}


//*** BMPZeile ***//
class BMPZeile {
  FILE* bild;
  int hoehe,breite,modweite,position;
  unsigned char *zeile;
  unsigned char *puffer;
  unsigned char *palette;
  long int colors;
  int offen;
public:
  BMPZeile(char *filename);
  ~BMPZeile(void);
  int eof(void);
  void HoleZeile(void);
  unsigned char getPixel(int pos) {return zeile[pos];}
  int getBreite() {return breite;}
  int getHoehe() {return hoehe;}
  long int getColors() {return colors;}
  unsigned char* getPalette() {return palette;}
};

BMPZeile::BMPZeile(char *filename) {
  unsigned char *headerbuffer;
  char string[256];
  long int longbuffer[1];
  long int *lwidth, *lheight, *pcolors;

  position=0;
  offen=0;
  printf("Opening %s ",filename);
  bild=fopen(filename,"rb");
  assert(bild);
  offen=1;
  fread(string,1,10,bild);
  if (strncmp(string,"BM",2)!=0) {
	 printf("no .BMP file\n");
  };
  fread(longbuffer,sizeof(long int),1,bild);
  headerbuffer=(unsigned char*)malloc(*longbuffer);
  palette=(unsigned char*)malloc(4*256);

  fread(headerbuffer,1,(size_t)40/*(*longbuffer)-14-1024*/,bild);
  pcolors=(long int *)(headerbuffer+32);
  colors=*pcolors;
  fread(palette,1,(size_t)4*colors,bild);
  lwidth=(long int *)(headerbuffer+4);
  lheight=(long int *)(headerbuffer+8);
  breite = (int)(*lwidth);
  hoehe = (int)(*lheight);
  modweite = ( 4 - breite % 4 )%4;
  free(headerbuffer);
  zeile=(unsigned char *)malloc(breite+modweite);
  if ((breite+modweite)*hoehe<65536) {
	 puffer=(unsigned char *)malloc((breite+modweite)*hoehe);
	 fread(puffer,1,(breite+modweite)*hoehe,bild);
	 fclose(bild);
	 offen=0;
  }
  HoleZeile();
};

BMPZeile::~BMPZeile(void) {
  if (offen) fclose(bild);
  offen=0;
  free(zeile);
  free(palette);
}

void BMPZeile::HoleZeile(void) {
  if (offen) fread(zeile,1,breite+modweite,bild);
  else for (int i=0;i<breite;i++) zeile[i]=puffer[position*(breite+modweite)+i];
  position++;
}

int BMPZeile::eof() {
  return (position>hoehe);
}

int FindOption(char option) {
  int i;
  int gefunden=0;
  option=toupper(option);
  for (i=1;i<_argc && !gefunden;i++) {
	 gefunden|=(_argv[i][0]=='-' && toupper(_argv[i][1])==option);
  }
  if (gefunden) return i; else return 0;
}

int AnzahlBilder(const char *anfang) {
  char name[100];
  char drive[MAXDRIVE];
  char dir[MAXDIR];
  char ext[MAXEXT];
  struct find_t blk;
  int maxnr=0;
  int nr=0;
  strcpy(name,anfang);
  strcat(name,"*.BMP");
  if (_dos_findfirst(name,_A_NORMAL,&blk)==0) {
	 do {
		fnsplit(blk.name,drive,dir,name,ext);
		strncpy(name,&name[strlen(anfang)],strlen(name)-strlen(anfang));
		nr=atoi(name);
		if (nr>maxnr) maxnr=nr;
	 } while (_dos_findnext(&blk)==0);
  }
  return maxnr;
}
															/*gruen blau rot alpha*/
unsigned char schwarzweiss[2][4]={{0,0,0,0},{255,255,255,0}};

void main(int , char* args[]) {
  BMPZeile *bild[500];
  char Name[100],buf[20];
  WriteBMPFile *out;
  int hoehe;
  int w=1;
  int z=1;
  int t=0;
  int xpictures;
  int ypictures;
  int faktor=1;
  int zpos;
  int wpos;
  int xpos;
  int xpicpos;
  int opos=FindOption('O');
  int mpos=FindOption('M');
  int tpos=FindOption('T');
  int lpos=FindOption('L');
  int ppos=FindOption('P');
  if (!(opos || mpos) || !(lpos || ppos) ) {
	 printf("*** Cologram ***                         Florian Schreck 4.12.1997\n");
	 printf("This program can be used to merge several .BMP images into one image\n");
	 printf("to generate a Cologram. Syntax:\n\n");
	 printf("Cologram -P pict [-L one two ... end] -O output -M mask [Options]\n\n");
	 printf("one,two,...,end are the names of the pictures which will be merged using -L\n");
	 printf("pict01 to pictN are the names of the pictures which will be merged using -P\n");
	 printf("without the extension .BMP. output and mask are the names of the output pictures");
	 printf("They should be in the 8bit BMP Format, all should use the same palette\n");
	 printf("and have the same size.\n");
	 printf("Options:\n\n");
	 printf("  -Z repeat_lines : repeats the lines repeat_lines times\n");
	 printf("  -W white_space  : width of the white comlumns in the mask in pixels\n");
	 printf("  -X factor       : increase mask resolution by factor\n");
	 printf("  -T testheight   : create testpictures of height testheight\n");
	 printf("  -N X-Pictures   : creates X/Y Cologram with N pictures in X direction\n\n");
	 printf("Example:\n\n");
	 printf("Cologram -P dragon -O dragon -M mask\n\n");
	 printf("(use -Z 3 -X 2 to get a white spacing of 1.5)");
	 exit(1);
  }
  if (opos==0) opos=999;
  if (mpos==0) mpos=999;
  int max;
  if (ppos) {
	 max=AnzahlBilder(args[ppos]);
	 printf("Opening %i pictures...\n",max);
	 for (int i=1;i<=max;i++) {
		sprintf(Name,"%i",i);
		buf[0]=0;
		switch (strlen(Name)) {
		  case 1:
			 if (max>=100) strcpy(buf,"00");
			 else if (max>=10) strcpy(buf,"0");
		  break;
		  case 2:
			 if (max>=100) strcpy(buf,"0");
		  break;
		}
		strcat(buf,Name);
		strcpy(Name,args[ppos]);
		strcat(Name,buf);
		strcat(Name,".BMP");
		bild[i]=new BMPZeile(Name);
	 }
  } else if (lpos) {
	 max=((opos<mpos) ? opos:mpos)-lpos-1;
	 printf("Opening %i pictures...\n",max);
	 for (int i=0;i<max;i++) {
		strcpy(Name,args[lpos+i]);
		strcat(Name,".bmp");
		bild[i+1]=new BMPZeile(Name);
	 }
  } else {
	 printf("error, no -l or -p found\n");
	 exit(1);
  }
  if (zpos=FindOption('Z')) z=atoi(args[zpos]);
  if (wpos=FindOption('W')) w=atoi(args[wpos]);
  if (xpos=FindOption('X')) faktor=atoi(args[xpos]);
  if (xpicpos=FindOption('N')) xpictures=atoi(args[xpicpos]); else xpictures=max;
  ypictures=max/xpictures;
  if (xpictures*ypictures!=max) {
	 printf("Number of pictures <> X-Pictures*Y-Pictures\n");
	 exit(1);
  }
  if (w>=max) w=max-1;
  if (tpos=FindOption('T')) t=atoi(args[tpos]);
  if (t==0) hoehe=bild[1]->getHoehe()*z*ypictures;
  else {
	 hoehe=t*z*ypictures;
	 printf("Teststreifen ");
  }
  if (opos!=999) {
	 printf("\nOutput File: X:%i, Y:%i ",bild[1]->getBreite()*xpictures,hoehe);
	 strcpy(Name,args[opos]);
	 strcat(Name,".bmp");
	 out=new WriteBMPFile(Name,bild[1]->getBreite()*xpictures,hoehe,bild[1]->getColors(),bild[1]->getPalette());
	 int l=0;
	 int StreifenNummer=0;
	 while (l<hoehe) {
		for (int i=0;i<(bild[1]->getBreite());i++) {
		  for (int j=1;j<=xpictures;j++) out->Pixel(bild[StreifenNummer*xpictures+j]->getPixel(i));
		}
		for (int j=1;j<=xpictures;j++) bild[StreifenNummer*xpictures+j]->HoleZeile();
		StreifenNummer++;
		if (StreifenNummer>=ypictures) StreifenNummer=0;
		for (int h=0;h<z;h++) {
		  out->WriteLine();
		  l++;
		}
		out->NewLine();
	 }
	 delete out;
  }
  if (mpos!=999) {
	 strcpy(Name,args[mpos]);
	 strcat(Name,".bmp");
	 out=new WriteBMPFile(Name,bild[1]->getBreite()*xpictures*faktor,hoehe*faktor,2,(unsigned char *)&schwarzweiss);
	 for (int x=0;x<bild[1]->getBreite()*faktor;x++) {
		int n=0;
		for (int j=0;j<(xpictures*faktor-w)/2;j++) {out->Pixel(0);n++;}
		for (j=0;j<w;j++) {out->Pixel(1);n++;}
		for (j=0;j<xpictures*faktor-n;j++) out->Pixel(0);
	 }
	 for (int f=0;f<hoehe/ypictures;f++) {
		for (int n=0;n<faktor;n++) out->WriteLine();
		if (ypictures>1) {
		  out->NewLine();
		  for (int x=0;x<bild[1]->getBreite()*xpictures*faktor;x++) out->Pixel(0);
		  for (int y=faktor;y<ypictures*faktor;y++) out->WriteLine();
		  out->NewLine();
		  for (x=0;x<bild[1]->getBreite()*faktor;x++) {
			 int n=0;
			 for (int j=0;j<(xpictures*faktor-w)/2;j++) {out->Pixel(0);n++;}
			 for (j=0;j<w;j++) {out->Pixel(1);n++;}
			 for (j=0;j<xpictures*faktor-n;j++) out->Pixel(0);
		  }
		}
	 }
	 delete out;
  }
  for (int j=1;j<=max;j++) delete bild[j];
}
